SystemOrganization addCategory: #'Seaside-Configuration-NG'!
SystemOrganization addCategory: #'Seaside-Configuration-NG-Sample'!

WAObject subclass: #WAAttributeNG
	instanceVariableNames: 'key default hasDefault'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Configuration-NG'!

!WAAttributeNG class methodsFor: 'instance creation' stamp: 'pmm 2/2/2014 18:57'!
key: aSymbol
	^ self basicNew
		initializeWithKey: aSymbol! !

!WAAttributeNG methodsFor: 'accessing' stamp: 'pmm 2/2/2014 15:55'!
default
	^ default! !

!WAAttributeNG methodsFor: 'accessing' stamp: 'pmm 2/2/2014 15:02'!
default: anObject
	default := anObject.
	hasDefault := true! !

!WAAttributeNG methodsFor: 'accessing' stamp: 'pmm 2/2/2014 15:55'!
hasDefault
	^ hasDefault! !

!WAAttributeNG methodsFor: 'initialization' stamp: 'pmm 2/2/2014 15:03'!
initializeWithKey: aSymbol
	self initialize.
	key := aSymbol.
	hasDefault := false! !

!WAAttributeNG methodsFor: 'accessing' stamp: 'pmm 2/2/2014 15:59'!
key
	^ key! !

WAObject subclass: #WAConfigurationDefinitionNG
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Configuration-NG'!

!WAConfigurationDefinitionNG methodsFor: 'description' stamp: 'pmm 2/2/2014 18:54'!
describeOn: config
	self subclassResponsibility! !

WAConfigurationDefinitionNG subclass: #WASampleConfigurationDefinitionNG
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Configuration-NG-Sample'!

!WASampleConfigurationDefinitionNG methodsFor: 'description' stamp: 'pmm 2/2/2014 18:58'!
describeOn: config
	config addAttribute: (
		(WAAttributeNG key: #attribute1)
			default: nil;
			yourself)! !

WAObject subclass: #WAConfigurationDescriptionNG
	instanceVariableNames: 'attributes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Configuration-NG'!

!WAConfigurationDescriptionNG methodsFor: 'public' stamp: 'pmm 2/2/2014 18:56'!
addAttribute: anAttribute! !

!WAConfigurationDescriptionNG methodsFor: 'enumerating' stamp: 'pmm 2/2/2014 15:57'!
attributesDo: aOneArgumentBlock
	attributes do: aOneArgumentBlock! !

WAObject subclass: #WAConfigurationNG
	instanceVariableNames: 'configurationDescription values'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Configuration-NG'!

!WAConfigurationNG methodsFor: 'accessing' stamp: 'pmm 2/2/2014 19:00'!
at: aSymbol
	^ self at: aSymbol ifAbsent: [ self valueNotFound: aSymbol ]! !

!WAConfigurationNG methodsFor: 'accessing' stamp: 'pmm 2/2/2014 19:00'!
at: aSymbol ifAbsent: aNiladicBlock
	^ (values
		at: aSymbol
		ifAbsent: [
			^ aNiladicBlock value ]) contents! !

!WAConfigurationNG methodsFor: 'accessing' stamp: 'pmm 2/2/2014 19:03'!
at: aSymbol put: anObject
	values at: aSymbol put: (WAValueHolder contents: anObject).
	^ anObject! !

!WAConfigurationNG methodsFor: 'initialization' stamp: 'pmm 2/2/2014 11:53'!
initialize
	super initialize.
	values := IdentityDictionary new! !

!WAConfigurationNG methodsFor: 'initialization' stamp: 'pmm 2/2/2014 19:04'!
initializeWith: aConfigurationDescription overwriteDefaults: aBoolean
	configurationDescription = aConfigurationDescription.
	aConfigurationDescription attributesDo: [ :each |
		each hasDefault ifTrue: [
			(aBoolean or: [ values includesKey: each key ]) ifTrue: [
				self at: each key put: each value ] ] ]! !

!WAConfigurationNG methodsFor: 'private' stamp: 'pmm 2/2/2014 11:57'!
valueNotFound: aSymbol
	self error: 'no value found for attribute: ', aSymbol greaseString! !

WAConfigurationNG subclass: #WASharedConfigurationNG
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Configuration-NG'!

!WASharedConfigurationNG methodsFor: 'accessing' stamp: 'pmm 2/2/2014 19:04'!
name
	^ name! !

WAConfigurationNG subclass: #WAUserConfigurationNG
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Configuration-NG'!

WAUserConfigurationNG subclass: #WAInheritableUserConfigurationNG
	instanceVariableNames: 'parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Configuration-NG'!

!WAInheritableUserConfigurationNG methodsFor: 'accessing' stamp: 'pmm 2/2/2014 19:02'!
at: aSymbol ifAbsent: aNiladicBlock
	^ super
		at: aSymbol
		ifAbsent: [
			parent
				at: aSymbol
				ifAbsent: aNiladicBlock ]! !

WAObject subclass: #WARequestHandlerNG
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Configuration-NG-Sample'!

WARequestHandlerNG subclass: #WAApplicationNG
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Configuration-NG-Sample'!
